#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#ifdef __THINK__
#define MAC
#define macintosh
#endif

#define BELL            '\007'          /* bell character */
#define LEN_str         40                      /* generic string length */
#define MAX_ID          50
#define PI                      3.14159265

#include <mfhdf.h>

#define LOCATION                "APS:6-BM-R"
#define PROG_NAM                "ORDIF"
#define VERSION                 "0.1 alpha"
#define MAX_SDS_LEN             23                      /* maximum allowed
length of an SDS name */
#define MAX_MOTOR_LEN   27                      /* maximum allowed length
of a motor name*/

#define hiw(j)          ( (j)/65536 )
#define low(j)          ( (j)%65536 )

int32 sdstring(int32 sfid, char *sd_name,char *string);
void entry_log(int entry, int32 vgN, int32 vgD, int id, int Did, int32
sid[], int32 Dsid[]);

void main(void)
{
        int32           dim1[1]={1};
        int32           edge1[1]={1};
        int32           dims[10],edge[10];
        int32           start0[]={0,0,0,0,0,0,0,0,0};   /* max possible
rank defined at start*/
        int32           int_fill = -1;   /* used to flag non-existant data */
        float32         float_fill = -1.0;
        int32           j, ii, iii;
        int                     i;
/* index of loops [0,dim] */
        int16           i16;
        float32         x;
        int16           one16 = 1;
/* a 16 bit one, used with DFNT_INT16 */
        char            equation[255];
        char            *file_name = "examples.hdf";
        char            *user_name = "John Q. Public";
        char            *user_mail = "Chemistry Dept.\nBerkeley U.\n CA  11111";
        char            *user_email = "joe@pdp8.chem.mit.edu";
        char            *user_phone = "900-555-1212";
        char            *user_fax = "900-555-1213";

        int32           sfid,vfid;
/* HDF column identifiers */
        int32           vgN;
/* HDF group identifier for entry */
        int32           vgD;
/* HDF group identifier for data1 */
        int32           sid[MAX_ID],Dsid[MAX_ID];
        int                     id,Did;

        int32           dim_id, ierr;
        float32         CCD_x_axis[64],CCD_y_axis[64];
        int16           ccd_data[11][64][64];

        float32         gain, gain1, gain2;
        float32         lo,hi,absorption_corr,deadtime;
        float32         hutch_pressure,hutch_temperature,temperature;
        float32         hkl_near[3];

        float32         mono_energy[501];
        float32         theta[51];
        float32         ttheta[51];
        float32         chi[51];
        float32         phi[51];
        float32         h1[360], k1[360], l1[360];
        int32           ic1[501];
        int32           ic2[501];
        int32           scint[360];
        float32         computed[501];

        float32         h1a[21][21], k1a[21][21], l1a[21][21];
        int32           ic1a[21][21];
        float32         computeda[21][21];

/* open the file for Vset and SD */

        printf("opening file\n");
        sfid = SDstart(file_name, DFACC_CREATE);
        vfid = Hopen(file_name,DFACC_RDWR,0);
        Vstart(vfid);

/* write global attributes to the file */

        printf("writing global attributes\n");
        i = SDsetattr(sfid,"file_name",DFNT_CHAR8,strlen(file_name),file_name);
        i = SDsetattr(sfid,"version",DFNT_CHAR8,strlen(VERSION),VERSION);
        i16 = MAX_SDS_LEN;
        i = SDsetattr(sfid,"MAX_SDS_LEN",DFNT_INT16,1,(VOIDP) &i16);
        i16 = MAX_MOTOR_LEN;
        i = SDsetattr(sfid,"MAX_MOTOR_LEN",DFNT_INT16,1,(VOIDP) &i16);

/* entry_default,  The default entry. */

        printf("\n\nstarting 'entry_default'\n");
        vgN = Vattach(vfid,-1,"w");
        Vsetname(vgN,"entry_default");                  /* this name is
required */
        Vsetclass(vgN,"APS_default");                   /* this class is
required */
        id = -1;

        sid[++id] = sdstring(sfid,"location",LOCATION);
        sid[++id] = sdstring(sfid,"program_name",PROG_NAM);
        sid[++id] = sdstring(sfid,"user_name",user_name);
        i =
SDsetattr(sid[id],"user_mail",DFNT_CHAR8,strlen(user_mail),user_mail);
        i =
SDsetattr(sid[id],"user_email",DFNT_CHAR8,strlen(user_email),user_email);
        i =
SDsetattr(sid[id],"user_phone",DFNT_CHAR8,strlen(user_phone),user_phone);
        i = SDsetattr(sid[id],"user_fax",DFNT_CHAR8,strlen(user_fax),user_fax);
        sid[++id] = SDcreate(sfid,"h",DFNT_FLOAT32,1,dim1);             /*
default, sets h1 */
        SDsetattr(sid[id],"diffract_axis",DFNT_CHAR8,2,"h1");
        sid[++id] = SDcreate(sfid,"k",DFNT_FLOAT32,1,dim1);
/*default, sets k1 */
        SDsetattr(sid[id],"diffract_axis",DFNT_CHAR8,2,"k1");
        sid[++id] = SDcreate(sfid,"l",DFNT_FLOAT32,1,dim1);
/*default, sets l1 */
        SDsetattr(sid[id],"diffract_axis",DFNT_CHAR8,2,"l1");
        sid[++id] = SDcreate(sfid,"theta",DFNT_FLOAT32,1,dim1); /*default,
sets theta*/
        SDsetattr(sid[id],"diffract_axis",DFNT_CHAR8,6,"theta");
        sid[++id] = SDcreate(sfid,"2theta",DFNT_FLOAT32,1,dim1);/*default,
set 2theta */
        SDsetattr(sid[id],"diffract_axis",DFNT_CHAR8,7,"2theta");
        sid[++id] = SDcreate(sfid,"chi",DFNT_FLOAT32,1,dim1);   /*default,
sets chi */
        SDsetattr(sid[id],"diffract_axis",DFNT_CHAR8,3,"chi");
        sid[++id] = SDcreate(sfid,"phi",DFNT_FLOAT32,1,dim1);   /*default,
sets phi */
        SDsetattr(sid[id],"diffract_axis",DFNT_CHAR8,3,"phi");

        entry_log(-1, vgN, vgD, id, (int32) -1, sid, Dsid);
        for (i=0;i<=id;i++) {
		ierr = Vaddtagref(vgN,DFTAG_NDG,SDidtoref(sid[i]));
		SDendaccess(sid[i]);
		printf("ierr=%d\n", ierr);
	}
        Vdetach(vgN);

/* entry1,  The maximally minimal entry. */

        printf("\n\nstarting 'entry1'\n");
        vgN = Vattach(vfid,-1,"w");
        Vsetname(vgN,"entry1");
        Vsetclass(vgN,"APS_entry");
        id = -1;

        sid[++id] = sdstring(sfid,"date","22-feb-1996");
        sid[++id] = sdstring(sfid,"hour","23:59:59.00 UT");
        sid[++id] = sdstring(sfid,"entry_analysis","NONE");
        sid[++id] = sdstring(sfid,"entry_intent","misc");

        entry_log(1, vgN, vgD, id, (int32) -1, sid, Dsid);
        for (i=0;i<=id;i++) Vaddtagref(vgN,DFTAG_NDG,SDidtoref(sid[i]));
        for (i=0;i<=id;i++) SDendaccess(sid[i]);
        Vdetach(vgN);

/* entry2,  A simple EXAFS scan with log ratio stored in data file. */

        printf("\n\nstarting 'entry2'\n");
        for (i=0;i<501;i++) {                           /* make a dummy
scan of 501 points */
                mono_energy[i] = 20. + .001 * i;
                ic1[i] = 200000;
                ic2[i] = 100000 + 2*i;
        }
        edge[0]=dims[0]=501;                            /* scan of 501
points, rank=1 */
        gain1 = gain2 = 1.e8;
        vgN = Vattach(vfid,-1,"w");
        Vsetname(vgN,"entry2");
        Vsetclass(vgN,"APS_entry");
        id = -1;

        sid[++id] = sdstring(sfid,"date","23-feb-1996");
        sid[++id] = sdstring(sfid,"hour","00:10:59.10 -7");
        sid[++id] = sdstring(sfid,"entry_analysis","EXAFS");
        sid[++id] = sdstring(sfid,"entry_intent","data");
        sid[++id] = sdstring(sfid,"title","Mo K-edge");

        vgD = Vattach(vfid,-1,"w");
        Vsetname(vgD,"data1");
        Vsetclass(vgD,"APS_scan");
        Did = -1;

        Dsid[++Did] = SDcreate(sfid,"mono_energy",DFNT_FLOAT32,1,dims);
        SDsetdatastrs(Dsid[Did],"energy","keV","%.5","");
        SDsetattr(Dsid[Did],"axis",DFNT_INT16,1,(VOIDP) &one16);
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) mono_energy);

        Dsid[++Did] = SDcreate(sfid,"ic1",DFNT_INT32,1,dims);
        SDsetattr(Dsid[Did],"gain",DFNT_FLOAT32,1,(VOIDP) &gain1);
/*        SDsetattr(Dsid[Did],"I_monitor",DFNT_NONE,1,NULL); */
        SDsetdatastrs(Dsid[Did],"monitor","photons","%.5","");
        SDsetfillvalue(Dsid[Did],(VOIDP) &int_fill);
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) ic1);

        Dsid[++Did] = SDcreate(sfid,"ic2",DFNT_INT32,1,dims);
        SDsetattr(Dsid[Did],"gain",DFNT_FLOAT32,1,(VOIDP) &gain2);
        SDsetattr(Dsid[Did],"signal",DFNT_INT16,1,(VOIDP) &one16);
        SDsetdatastrs(Dsid[Did],"detector","photons","%.5","");
        SDsetfillvalue(Dsid[Did],(VOIDP) &int_fill);
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) ic2);

        for (i=0;i<dims[0];i++) { computed[i] = log( (float) ic2[i]/ic1[i]); }
        Dsid[++Did] = SDcreate(sfid,"corrected_signal",DFNT_FLOAT32,1,dims);
        strcpy(equation,"log(ic2/ic1)");
        SDsetattr(Dsid[Did],"equation",DFNT_CHAR8,strlen(equation),equation);
        SDsetattr(Dsid[Did],"primary",DFNT_INT16,1,(VOIDP) &one16);
        SDsetdatastrs(Dsid[Did],"log(ic2/ic1)","","%.5","");
        SDsetfillvalue(Dsid[Did],(VOIDP) &float_fill);
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) computed);

        entry_log(2, vgN, vgD, id, Did, sid, Dsid);
        for (i=0;i<=Did;i++) Vaddtagref(vgD,DFTAG_NDG,SDidtoref(Dsid[i]));
        for (i=0;i<=Did;i++) SDendaccess(Dsid[i]);
        Vdetach(vgD);
        for (i=0;i<=id;i++) Vaddtagref(vgN,DFTAG_NDG,SDidtoref(sid[i]));
        for (i=0;i<=id;i++) SDendaccess(sid[i]);
        Vaddtagref(vgN,DFTAG_VG,vgD);
        Vdetach(vgN);

/*
 * entry3,  A theta scan of 10 intervals with one counter and one CCD image
 * saved at each point (64 x 64).
 */

        printf("\n\nstarting 'entry3'\n");
        for (i=0;i<11;i++) {                            /* make a dummy
scan of 11 points */
                theta[i] = 10.+ i;
                ic1[i] = 200000;
                scint[i] = 250 + i;
                for (ii=0;ii<64;ii++) {
                        for (iii=0;iii<64;iii++) ccd_data[i][ii][iii] =
1000*i + 100*ii + iii;
                }
        }
        edge[0]=dims[0]=11;
        edge[1]=edge[2]=dims[1]=dims[2]=64;
        vgN = Vattach(vfid,-1,"w");
        Vsetname(vgN,"entry3");
        Vsetclass(vgN,"APS_entry");
        id = -1;

        sid[++id] = sdstring(sfid,"date","23-feb-1996");
        sid[++id] = sdstring(sfid,"hour","02:10:59.10 -7");
        sid[++id] = sdstring(sfid,"entry_analysis","diffraction/misc");
        sid[++id] = sdstring(sfid,"entry_intent","data");
        sid[++id] = sdstring(sfid,"title","fancy CCD scan");

        mono_energy[0] = 8.047;
        sid[++id] = SDcreate(sfid,"mono_energy",DFNT_FLOAT32,1,dim1);
        SDsetdatastrs(sid[id],"energy","keV","%.4","");
        SDwritedata(sid[id],start0,NULL,dim1,(VOIDP) mono_energy);

        vgD = Vattach(vfid,-1,"w");
        Vsetname(vgD,"data1");
        Vsetclass(vgD,"APS_scan");
        Did = -1;

        /* the SDsetattr for "diffract_axis" is redundant, see entry_default */
        Dsid[++Did] = SDcreate(sfid,"theta",DFNT_FLOAT32,1,dims);
        SDsetdatastrs(Dsid[Did],"theta","degrees","%.3","");
        SDsetattr(Dsid[Did],"axis",DFNT_INT16,1,(VOIDP) &one16);
        SDsetattr(Dsid[Did],"diffract_axis",DFNT_CHAR8,6,"theta");
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) theta);

        Dsid[++Did] = SDcreate(sfid,"ic1",DFNT_INT32,1,dims);
        SDsetattr(Dsid[Did],"gain",DFNT_FLOAT32,1,(VOIDP) &gain1);
/*        SDsetattr(Dsid[Did],"I_monitor",DFNT_NONE,1,NULL); */
        SDsetdatastrs(Dsid[Did],"monitor","","%.5","");
        SDsetfillvalue(Dsid[Did],(VOIDP) &int_fill);
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) ic1);

        Dsid[++Did] = SDcreate(sfid,"scint",DFNT_INT32,1,dims);
/*        SDsetattr(Dsid[Did],"I_monitor",DFNT_NONE,1,NULL); */
        SDsetdatastrs(Dsid[Did],"flourescence detector","counts","%.0","");
        SDsetfillvalue(Dsid[Did],(VOIDP) &int_fill);
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) scint);

        Dsid[++Did] = SDcreate(sfid,"CCD",DFNT_INT16,3,dims);
        SDsetattr(Dsid[Did],"signal",DFNT_INT16,1,(VOIDP) &one16);
        SDsetattr(Dsid[Did],"primary",DFNT_INT16,1,(VOIDP) &one16);
        SDsetdatastrs(Dsid[Did],"CCD detector","photons","%.5","");
        SDgetdimid(Dsid[Did],2);
        i = SDsetdimscale(dim_id,dims[1],DFNT_FLOAT32,(VOIDP) CCD_x_axis);
        SDgetdimid(Dsid[Did],3);
        i = SDsetdimscale(dim_id,dims[2],DFNT_FLOAT32,(VOIDP) CCD_y_axis);
        SDsetfillvalue(Dsid[Did],(VOIDP) &int_fill);
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) ccd_data);

/*       Note, for a CCD there is more information to stored.  So, it is best to
 *      create another Vgroup called "CCD_spec", and attach it to the Vgroup vgN
 *      (not to vgD).  In this new Vgroup make numerous simple SDS's, one
for each
 *      piece of information.  The reason for using SDS's is so that you
can attach
 *      dimensions to the information.  For example to store an sid which refers
 *      to a dark current exposure, or distance from the CCD to the sample, etc.
 */

        entry_log(3, vgN, vgD, id, Did, sid, Dsid);
        for (i=0;i<=Did;i++) Vaddtagref(vgD,DFTAG_NDG,SDidtoref(Dsid[i]));
        for (i=0;i<=Did;i++) SDendaccess(Dsid[i]);
        Vdetach(vgD);
        for (i=0;i<=id;i++) Vaddtagref(vgN,DFTAG_NDG,SDidtoref(sid[i]));
        for (i=0;i<=id;i++) SDendaccess(sid[i]);
        Vaddtagref(vgN,DFTAG_VG,vgD);
        Vdetach(vgN);

/* entry4,  A line in hkl space.  The scan direction is along the [111] */

        printf("\n\nstarting 'entry4'\n");
        for (i=0;i<51;i++) {                            /* make a dummy
scan of 51 points */
                theta[i] = 10. + .02*i;
                ttheta[i] = 2*theta[i];
                chi[i] = 45.;
                phi[i] = 20.;
                h1[i] = k1[i] = l1[i] = 1. + i*0.002;
                ic1[i]  = 2000000;
                x = theta[i]-10.5;
                scint[i] = 3000. * exp(-(x*x/.1));
        }
        edge[0]=dims[0]=51;
        vgN = Vattach(vfid,-1,"w");
        Vsetname(vgN,"entry4");
        Vsetclass(vgN,"APS_entry");
        id = -1;

        sid[++id] = sdstring(sfid,"date","25-Feb-1996");
        sid[++id] = sdstring(sfid,"hour","02:10:59.10 -7");
        sid[++id] = sdstring(sfid,"entry_analysis","diffraction/misc");
        sid[++id] = sdstring(sfid,"entry_intent","data");
        sid[++id] = sdstring(sfid,"title","along the [111] direction");
        sid[++id] = sdstring(sfid,"constraint","delta_h = delta_k = delta_l");

        mono_energy[0] = 8.047;
        sid[++id] = SDcreate(sfid,"mono_energy",DFNT_FLOAT32,1,dim1);
        SDsetdatastrs(sid[id],"energy","keV","%.4","");
        SDwritedata(sid[id],start0,NULL,dim1,(VOIDP) mono_energy);

        vgD = Vattach(vfid,-1,"w");
        Vsetname(vgD,"data1");
        Vsetclass(vgD,"APS_scan");
        Did = -1;

        /* the next seven callso to SDsetattr for "diffract_axis" are redundant,
        see entry_default above */
        Dsid[++Did] = SDcreate(sfid,"theta",DFNT_FLOAT32,1,dims);
        SDsetdatastrs(Dsid[Did],"theta","degrees","%.3","");
        SDsetattr(Dsid[Did],"diffract_axis",DFNT_CHAR8,6,"theta");
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) theta);

        Dsid[++Did] = SDcreate(sfid,"2theta",DFNT_FLOAT32,1,dims);
        SDsetdatastrs(Dsid[Did],"2theta","degrees","%.3","");
        SDsetattr(Dsid[Did],"diffract_axis",DFNT_CHAR8,7,"2theta");
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) ttheta);

        Dsid[++Did] = SDcreate(sfid,"chi",DFNT_FLOAT32,1,dims);
        SDsetdatastrs(Dsid[Did],"chi","degrees","%.3","");
        SDsetattr(Dsid[Did],"diffract_axis",DFNT_CHAR8,3,"chi");
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) chi);

        Dsid[++Did] = SDcreate(sfid,"phi",DFNT_FLOAT32,1,dims);
        SDsetdatastrs(Dsid[Did],"phi","degrees","%.3","");
        SDsetattr(Dsid[Did],"diffract_axis",DFNT_CHAR8,3,"phi");
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) phi);

        Dsid[++Did] = SDcreate(sfid,"h1",DFNT_FLOAT32,1,dims);
        SDsetdatastrs(Dsid[Did],"h","","%.3","");
        SDsetattr(Dsid[Did],"diffract_axis",DFNT_CHAR8,2,"h1");
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) h1);

        Dsid[++Did] = SDcreate(sfid,"k1",DFNT_FLOAT32,1,dims);
        SDsetdatastrs(Dsid[Did],"k","","%.3","");
        SDsetattr(Dsid[Did],"diffract_axis",DFNT_CHAR8,2,"k1");
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) k1);

        Dsid[++Did] = SDcreate(sfid,"l1",DFNT_FLOAT32,1,dims);
        SDsetdatastrs(Dsid[Did],"l","","%.3","");
        SDsetattr(Dsid[Did],"diffract_axis",DFNT_CHAR8,2,"l1");
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) l1);

        for (i=0;i<dims[0];i++) { computed[i] =
sqrt(h1[i]*h1[i]+k1[i]*k1[i]+l1[i]*l1[i]); }
        Dsid[++Did] = SDcreate(sfid,"x-axis",DFNT_FLOAT32,1,dims);
        strcpy(equation,"sqrt(h*h+k*k+l*l)");
        SDsetattr(Dsid[Did],"equation",DFNT_CHAR8,strlen(equation),equation);
        SDsetattr(Dsid[Did],"axis",DFNT_INT16,1,(VOIDP) &one16);
        SDsetdatastrs(Dsid[Did],"distance along [111]","","%.5","");
        SDsetfillvalue(Dsid[Did],(VOIDP) &float_fill);
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) computed);

        Dsid[++Did] = SDcreate(sfid,"ic1",DFNT_INT32,1,dims);
        SDsetattr(Dsid[Did],"gain",DFNT_FLOAT32,1,(VOIDP) &gain1);
/*        SDsetattr(Dsid[Did],"I_monitor",DFNT_NONE,1,NULL); */
        SDsetdatastrs(Dsid[Did],"monitor","photons","%.5","");
        SDsetfillvalue(Dsid[Did],(VOIDP) &int_fill);
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) ic1);

        Dsid[++Did] = SDcreate(sfid,"scint",DFNT_INT32,1,dims);
        SDsetattr(Dsid[Did],"signal",DFNT_INT16,1,(VOIDP) &one16);
        SDsetattr(Dsid[Did],"primary",DFNT_INT16,1,(VOIDP) &one16);
        SDsetdatastrs(Dsid[Did],"detector","photons","%.5","");
        SDsetfillvalue(Dsid[Did],(VOIDP) &int_fill);
        SDsetattr(Dsid[Did],"analyzer",DFNT_CHAR8,5,"Ge111");
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) scint);

        entry_log(4, vgN, vgD, id, Did, sid, Dsid);
        for (i=0;i<=Did;i++) Vaddtagref(vgD,DFTAG_NDG,SDidtoref(Dsid[i]));
        for (i=0;i<=id;i++) SDendaccess(Dsid[i]);
        Vdetach(vgD);
        for (i=0;i<=id;i++) Vaddtagref(vgN,DFTAG_NDG,SDidtoref(sid[i]));
        for (i=0;i<=id;i++) SDendaccess(sid[i]);
        Vaddtagref(vgN,DFTAG_VG,vgD);
        Vdetach(vgN);

/* entry5,  A surface in hkl space.  The scan directions are along

        the [100] and [011] */
        printf("\n\nstarting 'entry5'\n");
        for (j=0;j<21;j++) {                            /* make a dummy
scan of 21 x 21 points */
                for (i=0;i<21;i++) {
                        h1a[j][i] = 1. + .1*j;
                        k1a[j][i] = l1a[j][i] = 1. + .05*i;
                        ic1a[j][i] = 20000;
                        x = (i-10)*(i-10) /.3 + (j-10)*(j-10)/.5;
                scint[i] = 1000. * exp(-x);
                }
        }
        edge[0]=edge[1]=dims[0]=dims[1]=21;
        vgN = Vattach(vfid,-1,"w");
        Vsetname(vgN,"entry5");
        Vsetclass(vgN,"APS_entry");
        id = -1;

        sid[++id] = sdstring(sfid,"date","25-Feb-1996");
        sid[++id] = sdstring(sfid,"hour","03:10:59.10 -7");
        sid[++id] = sdstring(sfid,"entry_analysis","diffraction/misc");
        sid[++id] = sdstring(sfid,"entry_intent","data");
        sid[++id] = sdstring(sfid,"title","the perpendicular surface");
        sid[++id] = sdstring(sfid,"constraint","perpendicular to (0 -1 1)");

        mono_energy[0] = 8.047;
        sid[++id] = SDcreate(sfid,"mono_energy",DFNT_FLOAT32,1,dim1);
        SDsetdatastrs(sid[id],"energy","keV","%.4","");
        SDwritedata(sid[id],start0,NULL,dim1,(VOIDP) mono_energy);

        vgD = Vattach(vfid,-1,"w");
        Vsetname(vgD,"data1");
        Vsetclass(vgD,"APS_scan");
        Did = -1;

        Dsid[++Did] = SDcreate(sfid,"h1",DFNT_FLOAT32,1,dims);
        SDsetdatastrs(Dsid[Did],"h","","%.3",""); /* diffract_axis
attribute set in entry_default */
        SDsetattr(Dsid[Did],"axis",DFNT_INT16,1,(VOIDP) &one16);
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) h1a);

        Dsid[++Did] = SDcreate(sfid,"k1",DFNT_FLOAT32,1,dims);
        SDsetdatastrs(Dsid[Did],"k","","%.3",""); /* diffract_axis
attribute set in entry_default */
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) k1a);

        Dsid[++Did] = SDcreate(sfid,"l1",DFNT_FLOAT32,1,dims);
        SDsetdatastrs(Dsid[Did],"l","","%.3",""); /* diffract_axis
attribute set in entry_default */
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) l1a);

        for (j=0;j<dims[0];j++) {
                for (i=0;i<dims[1];i++) {
                        computeda[j][i] =
sqrt(k1a[j][i]*k1a[j][i]+l1a[j][i]*l1a[j][i]);
                }
        }
        Dsid[++Did] = SDcreate(sfid,"y-axis",DFNT_FLOAT32,1,dims);
        strcpy(equation,"sqrt(k*k+l*l)");
        SDsetattr(Dsid[Did],"equation",DFNT_CHAR8,strlen(equation),equation);
        i16 = 2;
        SDsetattr(Dsid[Did],"axis",DFNT_INT16,1,(VOIDP) &i16);
        SDsetdatastrs(Dsid[Did],"distance along [011]","","%.3","");
        SDsetfillvalue(Dsid[Did],(VOIDP) &float_fill);
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) computeda);

        Dsid[++Did] = SDcreate(sfid,"ic1",DFNT_INT32,1,dims);
        SDsetattr(Dsid[Did],"gain",DFNT_FLOAT32,1,(VOIDP) &gain1);
/*        SDsetattr(Dsid[Did],"I_monitor",DFNT_NONE,1,NULL); */
        SDsetdatastrs(Dsid[Did],"monitor","photons","%.5","");
        SDsetfillvalue(Dsid[Did],(VOIDP) &int_fill);
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) ic1a);

        Dsid[++Did] = SDcreate(sfid,"scint",DFNT_INT32,1,dims);
        SDsetattr(Dsid[Did],"signal",DFNT_INT16,1,(VOIDP) &one16);
        SDsetattr(Dsid[Did],"primary",DFNT_INT16,1,(VOIDP) &one16);
        SDsetdatastrs(Dsid[Did],"detector","photons","%.5","");
        SDsetfillvalue(Dsid[Did],(VOIDP) &int_fill);
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) scint);

        entry_log(5, vgN, vgD, id, Did, sid, Dsid);
        for (i=0;i<=Did;i++) Vaddtagref(vgD,DFTAG_NDG,SDidtoref(Dsid[i]));
        for (i=0;i<=id;i++) SDendaccess(Dsid[i]);
        Vdetach(vgD);
        for (i=0;i<=id;i++) Vaddtagref(vgN,DFTAG_NDG,SDidtoref(sid[i]));
        for (i=0;i<=id;i++) SDendaccess(sid[i]);
        Vaddtagref(vgN,DFTAG_VG,vgD);
        Vdetach(vgN);

/* entry6,  A circle in hkl space, with points every degree. */

        printf("\n\nstarting 'entry6'\n");
        for (i=0;i<360;i++) {                           /* make a dummy
scan of 360 points */
                x = i * PI/180.;
                h1[i] = .1 * cos(x);
                k1[i] = .1 * sin(x);
                l1[i] = 2.;
                ic1[i] = 200000;
                scint[i] = pow(sin(x),10.);
        }
        edge[0]=dims[0]=360;
        vgN = Vattach(vfid,-1,"w");
        Vsetname(vgN,"entry6");
        Vsetclass(vgN,"APS_entry");
        id = -1;
        sid[++id] = sdstring(sfid,"date","25-Feb-1996");
        sid[++id] = sdstring(sfid,"hour","02:10:59.10 -7");
        sid[++id] = sdstring(sfid,"entry_analysis","diffraction/misc");
        sid[++id] = sdstring(sfid,"entry_intent","data");
        sid[++id] = sdstring(sfid,"title","0.1 rad circle about (002)");
        sid[++id] = sdstring(sfid,"constraint","|(hkl)-(002)|=.1 and (hkl)-(002) perpendicular to (002)");

        mono_energy[0] = 8.047;
        sid[++id] = SDcreate(sfid,"mono_energy",DFNT_FLOAT32,1,dim1);
        SDsetdatastrs(sid[id],"energy","keV","%.4","");
        SDwritedata(sid[id],start0,NULL,dim1,(VOIDP) mono_energy);

        hkl_near[0]=0;  hkl_near[1]=0;  hkl_near[2]=2;
        edge[0]=dims[0]=3;
        sid[++id] = SDcreate(sfid,"hkl_near",DFNT_FLOAT32,1,dims);
        SDwritedata(sid[id],start0,NULL,edge,(VOIDP) hkl_near);

        vgD = Vattach(vfid,-1,"w");
        Vsetname(vgD,"data1");
        Vsetclass(vgD,"APS_scan");
        Did = -1;
        edge[0]=dims[0]=360;

        Dsid[++Did] = SDcreate(sfid,"h1",DFNT_FLOAT32,1,dims);
        SDsetdatastrs(Dsid[Did],"h","","%.3","");       /* diffract_axsi
set to h1 in entry_default */
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) h1);

        Dsid[++Did] = SDcreate(sfid,"k1",DFNT_FLOAT32,1,dims);
        SDsetdatastrs(Dsid[Did],"k","","%.3","");       /* diffract_axsi
set to k1 in entry_default */
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) k1);

        Dsid[++Did] = SDcreate(sfid,"l1",DFNT_FLOAT32,1,dims);
        SDsetdatastrs(Dsid[Did],"l","","%.3","");       /* diffract_axsi
set to l1 in entry_default */
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) l1);

        for (i=0;i<dims[0];i++) { computed[i] = i; }
        Dsid[++Did] = SDcreate(sfid,"circle",DFNT_FLOAT32,1,dims);
        strcpy(equation,"angle");
        SDsetattr(Dsid[Did],"equation",DFNT_CHAR8,strlen(equation),equation);
        SDsetattr(Dsid[Did],"axis",DFNT_INT16,1,(VOIDP) &one16);
        SDsetdatastrs(Dsid[Did],"angle on circle","degrees","%.1","");
        SDsetfillvalue(Dsid[Did],(VOIDP) &float_fill);
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) computed);

        Dsid[++Did] = SDcreate(sfid,"ic1",DFNT_INT32,1,dims);
        SDsetattr(Dsid[Did],"gain",DFNT_FLOAT32,1,(VOIDP) &gain1);
/*        SDsetattr(Dsid[Did],"I_monitor",DFNT_NONE,1,NULL); */
        SDsetdatastrs(Dsid[Did],"monitor","photons","%.5","");
        SDsetfillvalue(Dsid[Did],(VOIDP) &int_fill);
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) ic1);

        Dsid[++Did] = SDcreate(sfid,"scint",DFNT_INT32,1,dims);
        SDsetattr(Dsid[Did],"signal",DFNT_INT16,1,(VOIDP) &one16);
        SDsetattr(Dsid[Did],"primary",DFNT_INT16,1,(VOIDP) &one16);
        SDsetdatastrs(Dsid[Did],"detector","photons","%.5","");
        SDsetfillvalue(Dsid[Did],(VOIDP) &int_fill);
        SDwritedata(Dsid[Did],start0,NULL,edge,(VOIDP) scint);

        entry_log(6, vgN, vgD, id, Did, sid, Dsid);
        for (i=0;i<=Did;i++) Vaddtagref(vgD,DFTAG_NDG,SDidtoref(Dsid[i]));
        for (i=0;i<=id;i++) SDendaccess(Dsid[i]);
        Vdetach(vgD);
        for (i=0;i<=id;i++) Vaddtagref(vgN,DFTAG_NDG,SDidtoref(sid[i]));
        for (i=0;i<=id;i++) SDendaccess(sid[i]);
        Vaddtagref(vgN,DFTAG_VG,vgD);
        Vdetach(vgN);

        printf("\n\ncalling end routines and closing the file\n");
        SDend(sfid);
        Vend(vfid);
        Hclose(vfid);
        putchar(BELL);
}





int32 sdstring(int32 sfid, char *sd_name,char *string)
/* this routine writes an SDS which only contins a single char string */
{
        int32           sid;
        int32           dim;
        int32           start=0;

        dim = strlen(string);
        sid = SDcreate(sfid,sd_name,DFNT_CHAR8,1,&dim);
        SDwritedata(sid,&start,NULL,&dim,string);
        return sid;
}





void entry_log(
int             entry,
int32   vgN,
int32   vgD,
int             id,
int             Did,
int32   sid[],
int32   Dsid[])
{
        int             i;
        char    str[60];
        int32   ref;

        if (entry>=1) sprintf(str,"entry%d",entry);
        else          strcpy(str,"entry_default");

        printf("   The Vgroup '%s' is id = %ld:%ld, and Vgroup 'data1' is id = %ld:%ld\n",str,hiw(vgN),low(vgN),hiw(vgD),low(vgD));
        printf("   The SDS's in '%s' are:\n",str);
        for (i=0;i<=id;i++) {
                ref = SDidtoref(sid[i]);
                printf("    %ld  =  %ld:%ld\n",sid[i],hiw(ref),low(ref));
                }

        if (Did<0) printf("\n   There is no 'data1' for %s\n",str);
        else       printf("\n   The SDS's in 'data1' of %s are:\n",str);
        for (i=0;i<=Did;i++) {
                ref =  SDidtoref(Dsid[i]);
                printf("    %ld  =  %ld:%ld\n",Dsid[i],hiw(ref),low(ref)); }

        return;
}


